if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[d%.][d%.][O%.]ns\\PitBull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 35392 $"):match("%d+"))

local PitBull = PitBull
local PitBull_Aura = PitBull:NewModule("Aura", "AceEvent-2.0", "AceConsole-2.0")
local self = PitBull_Aura
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-05-13 23:24:22 -0400 (Sun, 13 May 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local L = PitBull:L("PitBull-Aura")
local BS = AceLibrary("Babble-Spell-2.2")

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

local WoW21 = IsLoggedIn and true or false

local IsWackyUnit = PitBull.IsWackyUnit

local GetTime = GetTime
local GameTooltip = GameTooltip
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local GetPlayerBuff = GetPlayerBuff
local GetPlayerBuffName = GetPlayerBuffName
local GetPlayerBuffTexture = GetPlayerBuffTexture
local GetPlayerBuffDispelType = GetPlayerBuffDispelType
local GetPlayerBuffApplications = GetPlayerBuffApplications
local math_floor = math.floor
local math_min = math.min
local table_sort = table.sort
local unpack = unpack
local select = select

local canDispel, friendBuffs, friendDebuffs, selfBuffs, selfDebuffs, petBuffs, petDebuffs, enemyDebuffs
local playerClass, playerRace
do
	local _
	_, playerClass = UnitClass('player')
	_, playerRace = UnitRace('player')
	if playerClass == 'PRIEST' then
		canDispel = {
			["Magic"] = true,
			["Disease"] = true,
		}
		selfBuffs = {
			[BS["Blessed Recovery"]] = true,
			[BS["Fade"]] = true,
			[BS["Feedback"]] = playerRace == "Human" or nil,
			[BS["Focused Casting"]] = true,
			[BS["Inner Fire"]] = true,
			[BS["Inner Focus"]] = true,
			[BS["Levitate"]] = true,
			[BS["Pain Suppression"]] = true,
			[BS["Shadowform"]] = true,
			[BS["Shadowguard"]] = playerRace == "Troll" or nil,
			[BS["Touch of Weakness"]] = (playerRace == "BloodElf" or playerRace == "Scourge") or nil,
		}
		selfDebuffs = {
			[BS["Mind Vision"]] = true,
		}
		friendBuffs = {
			[BS["Divine Spirit"]] = true,
			[BS["Elune's Grace"]] = playerRace == "NightElf" or nil,
			[BS["Fear Ward"]] = (playerRace == "Draenei" or playerRace == "Dwarf") or nil,
			[BS["Power Infusion"]] = true,
			[BS["Power Word: Fortitude"]] = true,
			[BS["Power Word: Shield"]] = true,
			[BS["Prayer of Fortitude"]] = true,
			[BS["Prayer of Mending"]] = true,
			[BS["Prayer of Shadow Protection"]] = true,
			[BS["Prayer of Spirit"]] = true,
			[BS["Renew"]] = true,
			[BS["Symbol of Hope"]] = playerRace == "Draenei" or nil,
			[BS["Shadow Protection"]] = true,
		}
		enemyDebuffs = {
			[BS["Devouring Plague"]] = playerRace == "Scourge" or nil,
			[BS["Hex of Weakness"]] = playerRace == "Troll" or nil,
			[BS["Holy Fire"]] = true,
			[BS["Mind Control"]] = true,
			[BS["Mind Flay"]] = true,
			[BS["Mind Soothe"]] = true,
			[BS["Mind Vision"]] = true,
			[BS["Psychic Scream"]] = true,
			[BS["Shackle Undead"]] = true,
			[BS["Silence"]] = true,
			[BS["Shadow Word: Pain"]] = true,
			[BS["Starshards"]] = playerRace == "NightElf" or nil,
			[BS["Touch of Weakness"]] = (playerRace == "BloodElf" or playerRace == "Scourge") or nil,
			[BS["Vampiric Embrace"]] = true,
			[BS["Vampiric Touch"]] = true,
		}
		friendDebuffs = {
			[BS["Weakened Soul"]] = true,
		}
	elseif playerClass == 'SHAMAN' then
		canDispel = {
			["Poison"] = true,
			["Disease"] = true,
		}
		selfBuffs = {
			[BS["Clearcasting"]] = true,
			[BS["Elemental Devastation"]] = true,
			[BS["Elemental Mastery"]] = true,
			[BS["Far Sight"]] = true,
			[BS["Focused Casting"]] = true,
			[BS["Ghost Wolf"]] = true,
			[BS["Lightning Shield"]] = true,
			[BS["Nature's Swiftness"]] = true,
			[BS["Sentry Totem"]] = true,
			[BS["Shamanistic Rage"]] = true,
			[BS["Water Shield"]] = true,
		}
		friendBuffs = {
			[BS["Ancestral Fortitude"]] = true,
			[BS["Bloodlust"]] = (playerRace == "Troll" or playerRace == "Tauren" or playerRace == "Orc") or nil,
			[BS["Earth Shield"]] = true,
			[BS["Fire Resistance"]] = true,
			[BS["Frost Resistance"]] = true,
			[BS["Grace of Air"]] = true,
			[BS["Grounding Totem Effect"]] = true,
			[BS["Healing Stream"]] = true,
			[BS["Healing Way"]] = true,
			[BS["Heroism"]] = playerRace == "Draenei" or nil,
			[BS["Mana Spring"]] = true,
			[BS["Mana Tide"]] = true,
			[BS["Nature Resistance"]] = true,
			[BS["Stoneskin"]] = true,
			[BS["Strength of Earth"]] = true,
			[BS["Totem of Wrath"]] = true,
			[BS["Tranquil Air"]] = true,
			[BS["Water Breathing"]] = true,
			[BS["Water Walking"]] = true,
			[BS["Windwall"]] = true,
			[BS["Wrath of Air Totem"]] = true,
		}
		enemyDebuffs = {
			[BS["Earthbind"]] = true,
			[BS["Flame Shock"]] = true,
			[BS["Frost Shock"]] = true,
			[BS["Frostbrand Attack"]] = true,
			[BS["Stormstrike"]] = true,
			[BS["Stoneclaw Stun"]] = true,
		}
	elseif playerClass == 'PALADIN' then
		canDispel = {
			["Magic"] = true,
			["Poison"] = true,
			["Disease"] = true,
		}
		selfBuffs = {
			[BS["Avenging Wrath"]] = true,
			[BS["Divine Favor"]] = true,
			[BS["Divine Illumination"]] = true,
			[BS["Divine Protection"]] = true,
			[BS["Divine Shield"]] = true,
			[BS["Holy Shield"]] = true,
			[BS["Righteous Fury"]] = true,
			[BS["Seal of Blood"]] = playerRace == "BloodElf" or nil,
			[BS["Seal of Command"]] = true,
			[BS["Seal of Justice"]] = true,
			[BS["Seal of Light"]] = true,
			[BS["Seal of Righteousness"]] = true,
			[BS["Seal of Vengeance"]] = true,
			[BS["Seal of Wisdom"]] = true,
			[BS["Seal of the Crusader"]] = true,
			[BS["Sense Undead"]] = true,
			[BS["Summon Charger"]] = true,
			[BS["Summon Warhorse"]] = true,
		}
		friendBuffs = {
			[BS["Blessing of Freedom"]] = true,
			[BS["Blessing of Kings"]] = true,
			[BS["Blessing of Light"]] = true,
			[BS["Blessing of Might"]] = true,
			[BS["Blessing of Protection"]] = true,
			[BS["Blessing of Sacrifice"]] = true,
			[BS["Blessing of Salvation"]] = true,
			[BS["Blessing of Sanctuary"]] = true,
			[BS["Blessing of Wisdom"]] = true,
			[BS["Concentration Aura"]] = true,
			[BS["Crusader Aura"]] = true,
			[BS["Devotion Aura"]] = true,
			[BS["Divine Intervention"]] = true,
			[BS["Fire Resistance Aura"]] = true,
			[BS["Frost Resistance Aura"]] = true,
			[BS["Greater Blessing of Kings"]] = true,
			[BS["Greater Blessing of Light"]] = true,
			[BS["Greater Blessing of Might"]] = true,
			[BS["Greater Blessing of Salvation"]] = true,
			[BS["Greater Blessing of Sanctuary"]] = true,
			[BS["Greater Blessing of Wisdom"]] = true,
			[BS["Retribution Aura"]] = true,
			[BS["Sanctity Aura"]] = true,
			[BS["Shadow Resistance Aura"]] = true,
		}
		enemyDebuffs = {
			[BS["Avenger's Shield"]] = true,
			[BS["Consecration"]] = true,
			[BS["Hammer of Justice"]] = true,
			[BS["Judgement of Justice"]] = true,
			[BS["Judgement of Light"]] = true,
			[BS["Judgement of Wisdom"]] = true,
			[BS["Judgement of the Crusader"]] = true,
			[BS["Repentance"]] = true,
			[BS["Stun"]] = true, -- from Seal of Justice
			[BS["Turn Undead"]] = true,
		}
		friendDebuffs = {
			[BS["Forbearance"]] = true,
		}
	elseif playerClass == 'MAGE' then
		canDispel = {
			["Curse"] = true,
		}
		selfBuffs = {
			[BS["Arcane Power"]] = true,
			[BS["Blazing Speed"]] = true,
			[BS["Blink"]] = true,
			[BS["Clearcasting"]] = true,
			[BS["Combustion"]] = true,
			[BS["Evocation"]] = true,
			[BS["Fire Ward"]] = true,
			[BS["Frost Armor"]] = true,
			[BS["Frost Ward"]] = true,
			[BS["Ice Armor"]] = true,
			[BS["Ice Barrier"]] = true,
			[BS["Ice Block"]] = true,
			[BS["Invisibility"]] = true,
			[BS["Mage Armor"]] = true,
			[BS["Mana Shield"]] = true,
			[BS["Molten Armor"]] = true,
			[BS["Presence of Mind"]] = true,
			[BS["Slow Fall"]] = true,
		}
		friendBuffs = {
			[BS["Amplify Magic"]] = true,
			[BS["Arcane Brilliance"]] = true,
			[BS["Arcane Intellect"]] = true,
			[BS["Dampen Magic"]] = true,
		}
		selfDebuffs = {
			[BS["Arcane Blast"]] = true,
			[BS["Hypothermia"]] = true,
		}
		enemyDebuffs = {
			[BS["Blast Wave"]] = true,
			[BS["Blizzard"]] = true,
			[BS["Cone of Cold"]] = true,
			[BS["Chilled"]] = true,
			[BS["Detect Magic"]] = true,
			[BS["Dragon's Breath"]] = true,
			[BS["Fire Vulnerability"]] = true,
			[BS["Fireball"]] = true,
			[BS["Flamestrike"]] = true,
			[BS["Frost Armor"]] = true,
			[BS["Frost Nova"]] = true,
			[BS["Frostbite"]] = true,
			[BS["Frostbolt"]] = true,
			[BS["Ice Armor"]] = true,
			[BS["Ignite"]] = true,
			[BS["Impact"]] = true,
			[BS["Polymorph"]] = true,
			[BS["Polymorph: Pig"]] = true,
			[BS["Polymorph: Turtle"]] = true,
			[BS["Pyroblast"]] = true,
			[BS["Slow"]] = true,
		}
	elseif playerClass == 'DRUID' then
		canDispel = {
			["Curse"] = true,
			["Poison"] = true,
		}
		selfBuffs = {
			[BS["Aquatic Form"]] = true,
			[BS["Barkskin"]] = true,
			[BS["Bear Form"]] = true,
			[BS["Cat Form"]] = true,
			[BS["Clearcasting"]] = true,
			[BS["Dash"]] = true,
			[BS["Dire Bear Form"]] = true,
			[BS["Enrage"]] = true,
			[BS["Flight Form"]] = true,
			[BS["Frenzied Regeneration"]] = true,
			[BS["Moonkin Form"]] = true,
			[BS["Nature's Grasp"]] = true,
			[BS["Nature's Swiftness"]] = true,
			[BS["Omen of Clarity"]] = true,
			[BS["Prowl"]] = true,
			[BS["Swift Flight Form"]] = true,
			[BS["Tiger's Fury"]] = true,
			[BS["Track Humanoids"]] = true,
			[BS["Travel Form"]] = true,
		}
		friendBuffs = {
			[BS["Abolish Poison"]] = true,
			[BS["Gift of the Wild"]] = true,
			[BS["Innervate"]] = true,
			[BS["Leader of the Pack"]] = true,
			[BS["Lifebloom"]] = true,
			[BS["Mark of the Wild"]] = true,
			[BS["Moonkin Aura"]] = true,
			[BS["Regrowth"]] = true,
			[BS["Rejuvenation"]] = true,
			[BS["Thorns"]] = true,
			[BS["Tranquility"]] = true,
			[BS["Tree of Life"]] = true,
		}
		enemyDebuffs = {
			[BS["Bash"]] = true,
			[BS["Challenging Roar"]] = true,
			[BS["Cyclone"]] = true,
			[BS["Demoralizing Roar"]] = true,
			[BS["Entangling Roots"]] = true,
			[BS["Faerie Fire"]] = true,
			[BS["Faerie Fire (Feral)"]] = true,
			[BS["Feral Charge"]] = true,
			[BS["Hibernate"]] = true,
			[BS["Hurricane"]] = true,
			[BS["Insect Swarm"]] = true,
			[BS["Lacerate"]] = true,
			[BS["Maim"]] = true,
			[BS["Mangle (Bear)"]] = true,
			[BS["Mangle (Cat)"]] = true,
			[BS["Moonfire"]] = true,
			[BS["Pounce"]] = true,
			[BS["Rake"]] = true,
			[BS["Rip"]] = true,
			[BS["Soothe Animal"]] = true,
		}
	elseif playerClass == 'WARRIOR' then
		selfBuffs = {
			-- Trainer Skill
			[BS["Bloodrage"]] = true,
			[BS["Berserker Rage"]] = true,
			[BS["Retaliation"]] = true,
			[BS["Shield Wall"]] = true,
			[BS["Recklessness"]] = true,
			[BS["Spell Reflection"]] = true,
			[BS["Shield Block"]] = true,
			-- Talents: Arms
			[BS["Sweeping Strikes"]] = true,
			[BS["Second Wind"]] = true,
			-- Talents: Fury
			[BS["Bloodthirst"]] = true,
			[BS["Rampage"]] = true,
			[BS["Blood Craze"]] = true,
			[BS["Flurry"]] = true,
			[BS["Enrage"]] = true,
			-- Talents: Prot
			[BS["Last Stand"]] = true,
			-- T4, Tank, 2/4 piece bonus
			[BS["Blade Turning"]] = true,
			[BS["Revenge"]] = true,
			-- T5, Tank, 2/4 piece bonus
			[BS["Battle Rush"]] = true,
			[BS["Reinforced Shield"]] = true,
			-- T5, DPS, 2 piece bonus
			[BS["Overpower"]] = true,
		}
		selfDebuffs = {
			-- Talents: Fury
			[BS["Death Wish"]] = true,
		}
		friendBuffs = {
			-- Trainer
			[BS["Battle Shout"]] = true,
			[BS["Commanding Shout"]] = true,
			[BS["Intervene"]] = true,
		}
		enemyDebuffs = {
			-- Trainer Skill
			[BS["Charge Stun"]] = true,
			[BS["Hamstring"]] = true,
			[BS["Thunder Clap"]] = true,
			[BS["Rend"]] = true,
			[BS["Mocking Blow"]] = true,
			[BS["Demoralizing Shout"]] = true,
			[BS["Intimidating Shout"]] = true,
			[BS["Intercept Stun"]] = true,
			[BS["Taunt"]] = true,
			[BS["Dazed"]] = true,
			[BS["Disarm"]] = true,
			[BS["Challenging Shout"]] = true,
			[BS["Sunder Armor"]] = true,
			-- Talents: Arms
			[BS["Deep Wounds"]] = true,
			[BS["Improved Hamstring"]] = true,
			[BS["Mace Stun Effect"]] = true,
			[BS["Mortal Strike"]] = true,
			[BS["Blood Frenzy"]] = true,
			-- Talents: Fury
			[BS["Piercing Howl"]] = true,
			-- Talents: Prot
			[BS["Shield Bash - Silenced"]] = true,
			[BS["Revenge Stun"]] = true,
			[BS["Concussion Blow"]] = true,
		}
	elseif playerClass == 'WARLOCK' then
		canDispel = {
			["Magic"] = true,
		}
		selfBuffs = {
			-- Affliction Talents
			[BS["Amplify Curse"]] = true,
			[BS["Shadow Trance"]] = true,
			-- Demonology Talents
			[BS["Master Demonologist"]] = true,
			[BS["Soul Link"]] = true,
			[BS["Demonic Knowledge"]] = true,
			[BS["Demonic Sacrifice"]] = true,
			[BS["Fel Domination"]] = true,
			-- Destruction Talents
			[BS["Nether Protection"]] = true,
			[BS["Backlash"]] = true,
			-- Trainer Skills
			[BS["Shadow Ward"]] = true,
			[BS["Demon Armor"]] = true,
			[BS["Demon Skin"]] = true,
			[BS["Fel Armor"]] = true,
			[BS["Sense Demons"]] = true,
			[BS["Summon Felsteed"]] = true,
			[BS["Summon Dreadsteed"]] = true,
			-- Pet Abilities
			[BS["Sacrifice"]] = true,
		}
		friendBuffs = {
			-- Trainer Skills
			[BS["Soulstone Resurrection"]] = true,
			[BS["Unending Breath"]] = true,
			[BS["Detect Invisibility"]] = true,
			-- Pet Abilities
			[BS["Blood Pact"]] = true, -- Imp
			[BS["Fire Shield"]] = true, -- Imp
			[BS["Paranoia"]] = true, -- Felhound
			[BS["Demonic Frenzy"]] = true, -- Felguard
		}
		enemyDebuffs = {
			-- Trainer Skills - Affliction
			[BS["Corruption"]] = true,
			[BS["Curse of Agony"]] = true,
			[BS["Curse of Doom"]] = true,
			[BS["Curse of Recklessness"]] = true,
			[BS["Curse of Shadow"]] = true,
			[BS["Curse of Tongues"]] = true,
			[BS["Curse of Weakness"]] = true,
			[BS["Curse of the Elements"]] = true,
			[BS["Death Coil"]] = true,
			[BS["Fear"]] = true,
			[BS["Howl of Terror"]] = true,
			[BS["Drain Life"]] = true,
			[BS["Drain Mana"]] = true,
			[BS["Drain Soul"]] = true,
			[BS["Seed of Corruption"]] = true,
			-- Trainer Spells Demonology
			[BS["Banish"]] = true,
			--Trainer Spells Destruction
			[BS["Rain of Fire"]] = true,
			[BS["Hellfire"]] = true,
			[BS["Immolate"]] = true,
			-- Talents Affliction
			[BS["Curse of Exhaustion"]] = true,
			[BS["Siphon Life"]] = true,
			[BS["Shadow Embrace"]] = true,
			[BS["Unstable Affliction"]] = true,
			[BS["Silence"]] = true, -- Unstable Affliction dispel
			-- Talents Destruction
			[BS["Aftermath"]] = true,
			[BS["Shadowfury"]] = true,
			[BS["Pyroclasm"]] = true,
			[BS["Improved Shadow Bolt"]] = true,
			[BS["Shadowburn"]] = true,
			-- Pet Abilities
			[BS["Spell Lock"]] = true,  --Felhunter
			[BS["Tainted Blood"]] = true,  -- Felhunter
			[BS["Inferno"]] = true,  -- Infernal Stun ??
			[BS["Cripple"]] = true,  -- Doomguard
			[BS["Seduction"]] = true, -- Succubus
			[BS["Soothing Kiss"]] = true, -- Succubus
			[BS["Suffering"]] = true, -- Voidwalker
		}
	elseif playerClass == 'HUNTER' then
		selfBuffs = {
			[BS["Aspect of the Beast"]] = true,
			[BS["Aspect of the Cheetah"]] = true,
			[BS["Aspect of the Hawk"]] = true,
			[BS["Aspect of the Monkey"]] = true,
			[BS["Aspect of the Viper"]] = true,
			[BS["Deterrence"]] = true,
			[BS["Eagle Eye"]] = true,
			[BS["Eyes of the Beast"]] = true,
			[BS["Feign Death"]] = true,
			[BS["Master Tactician"]] = true,
			[BS["Quick Shots"]] = true,
			[BS["Rapid Fire"]] = true,
			[BS["Rapid Killing"]] = true,
			[BS["The Beast Within"]] = true,
		}
		friendBuffs = {
			[BS["Aspect of the Pack"]] = true,
			[BS["Aspect of the Wild"]] = true,
			[BS["Ferocious Inspiration"]] = true,	
			[BS["Misdirection"]] = true,
			[BS["Spirit Bond"]] = true,
			[BS["Trueshot Aura"]] = true,
		}
		petBuffs = {
			[BS["Bestial Wrath"]] = true,
			[BS["Boar Charge"]] = true,
			[BS["Feed Pet Effect"]] = true,
			[BS["Dash"]] = true,
			[BS["Dive"]] = true,
			[BS["Furious Howl"]] = true,
			[BS["Mend Pet"]] = true,
			[BS["Prowl"]] = true,
			[BS["Shell Shield"]] = true,
			[BS["Warp"]] = true,
		}
		enemyDebuffs = {
			[BS["Beast Lore"]] = true,
			[BS["Concussive Barrage"]] = true,
			[BS["Concussive Shot"]] = true,
			[BS["Counterattack"]] = true,
			[BS["Entrapment"]] = true,
			[BS["Explosive Trap Effect"]] = true,
			[BS["Expose Weakness"]] = true,
			[BS["Flare"]] = true,
			[BS["Freezing Trap Effect"]] = true,
			[BS["Frost Trap Aura"]] = true,
			[BS["Hunter's Mark"]] = true,
			[BS["Improved Concussive Shot"]] = true,
			[BS["Improved Wing Clip"]] = true,
			[BS["Intimidation"]] = true,
			[BS["Scare Beast"]] = true,
			[BS["Serpent Sting"]] = true,
			[BS["Scatter Shot"]] = true,
			[BS["Scorpid Sting"]] = true,
			[BS["Silencing Shot"]] = true,
			[BS["Tame Beast"]] = true,
			[BS["Viper Sting"]] = true,
			[BS["Wing Clip"]] = true,
			[BS["Wyvern Sting"]] = true,
			--snake trap
			[BS["Crippling Poison"]] = true,
			[BS["Deadly Poison"]] = true,
			[BS["Mind-numbing Poison"]] = true,
			--pets
			[BS["Boar Charge"]] = true,
			[BS["Fire Breath"]] = true,
			[BS["Growl"]] = true,
			[BS["Poison Spit"]] = true,
			[BS["Scorpid Poison"]] = true,
			[BS["Screech"]] = true,
		}
	elseif playerClass == 'ROGUE' then
		selfBuffs = {
			[BS["Stealth"]] = true,
			[BS["Evasion"]] = true,
			[BS["Slice and Dice"]] = true,
			[BS["Sprint"]] = true,
			[BS["Vanish"]] = true,
			[BS["Cloak of Shadows"]] = true,
			-- Talents: Assassination
			[BS["Remorseless"]] = true,
			[BS["Cold Blood"]] = true,
			[BS["Find Weakness"]] = true,
			-- Talents: Combat
			[BS["Blade Flurry"]] = true,
			[BS["Adrenaline Rush"]] = true,
			-- Talents: Subtlety
			[BS["Ghostly Strike"]] = true,
			[BS["Shadowstep"]] = true,
		}
		enemyDebuffs = {
			[BS["Sap"]] = true,
			[BS["Gouge"]] = true,
			[BS["Expose Armor"]] = true,
			[BS["Garrote"]] = true,
			[BS["Garrote - Silence"]] = true,
			[BS["Rupture"]] = true,
			[BS["Cheap Shot"]] = true,
			[BS["Kidney Shot"]] = true,
			[BS["Blind"]] = true,
			[BS["Deadly Throw"]] = true,
			-- Talents: Combat
			[BS["Riposte"]] = true,
			[BS["Kick - Silenced"]] = true,
			[BS["Mace Stun Effect"]] = true,
			-- Talents: Subtlety
			[BS["Hemorrhage"]] = true,
			-- Poison
			[BS["Crippling Poison"]] = true,
			[BS["Mind-numbing Poison"]] = true,
			[BS["Deadly Poison"]] = true,
			[BS["Wound Poison"]] = true,
			-- PVP Gloves
			[BS["Deadly Interrupt Effect"]] = true,
		}
	end
	if not canDispel then
		canDispel = {}
	end
	if not selfBuffs then
		selfBuffs = {}
	end
	if not selfDebuffs then
		selfDebuffs = {}
	end
	if not friendBuffs then
		friendBuffs = {}
	end
	if not enemyDebuffs then
		enemyDebuffs = {}
	end
	if not friendDebuffs then
		friendDebuffs = {}
	end
	if not petBuffs then
		petBuffs = {}
	end
	if not petDebuffs then
		petDebuffs = {}
	end
	if playerRace == "BloodElf" then
		enemyDebuffs[BS["Arcane Torrent"]] = true
		selfBuffs[BS["Mana Tap"]] = true
	elseif playerRace == "Troll" then
		selfBuffs[BS["Berserking"]] = true
	elseif playerRace == "Orc" then
		selfBuffs[BS["Blood Fury"]] = true
		selfDebuffs[BS["Blood Fury"]] = true
	elseif playerRace == "Scourge" then
		selfBuffs[BS["Cannibalize"]] = true
		selfBuffs[BS["Will of the Forsaken"]] = true
	elseif playerRace == "Dwarf" then
		selfBuffs[BS["Find Treasure"]] = true
		selfBuffs[BS["Stoneform"]] = true
	elseif playerRace == "Draenei" then
		friendBuffs[BS["Gift of the Naaru"]] = true
	elseif playerRace == "Human" then
		selfBuffs[BS["Perception"]] = true
	elseif playerRace == "NightElf" then
		selfBuffs[BS["Shadowmeld"]] = true
	elseif playerRace == "Tauren" then
		enemyDebuffs[BS["War Stomp"]] = true
	end
end

PitBull_Aura:RegisterPitBullChildFrames("auraFrame", "auraFrame2", "debuffhighlight")

local unitsShown = {}

local configMode = PitBull.configMode

local border_path = "Interface\\AddOns\\" .. debugstack():match("[d%.][d%.][O%.]ns\\(.+)\\[A-Za-z]-%.lua") .. "\\border"
local debuffHighlight_path = "Interface\\AddOns\\" .. debugstack():match("[d%.][d%.][O%.]ns\\(.+)\\[A-Za-z]-%.lua") .. "\\debuffHighlight"
local debuffHighlightBorder_path = "Interface\\AddOns\\" .. debugstack():match("[d%.][d%.][O%.]ns\\(.+)\\[A-Za-z]-%.lua") .. "\\debuffHighlightBorder"

function PitBull_Aura:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("Aura")
	PitBull:RegisterDefaults("Aura", "profile", {
		["**"] = {
			hidden = false,
			hiddenBuffs = false,
			hiddenDebuffs = false,
			highlight = { Buffs = true, Debuffs = true},
			highlightType = true,
			highlightStyle = "normal",
			split = false,
			snap = true,
			filter = true,
			maxbuffs = 6,
			maxdebuffs = 6,
			buffsize = 16,
			debuffsize = 16,
			flip = false,
			grow = -1,
			buffdirection = "Right then Down",
			debuffdirection = "Right then Down",
			frameHighlight = "Cureable by me",
			sort = true,
		},
		target = {
			filter = false,
			frameHighlight = "Never",
			maxbuffs = 40,
			maxdebuffs = 40,
		},
		colors = {
			buffs = {0, 1, 0, 1},
			debuffs = {
				Poison = {0, 1, 0, 1},
				Magic = {0, 0, 1, 1},
				Disease = {.55, .15, 0, 1},
				Curse = {5, 0, 5, 1},
				["nil"] = {1, 0, 0, 1},
			}
		},
		cooldown = true,
		cooldownText = false,
		cooldownTextAlpha = 0.5,
	})
end

function PitBull_Aura:OnEnable(first)
	self:RegisterBucketEvent("UNIT_AURA", 0.25)
	PitBull_Aura:ScheduleRepeatingEvent("PitBull_Aura-Update", self.UpdateAuraFrameTexts, 0.2, self)
end

function PitBull_Aura:UNIT_AURA(units)
	for unit in pairs(units) do
		for frame in PitBull:IterateUnitFramesForUnit(unit) do
			if unitsShown[frame] and not self.db.profile[frame.group].hidden then
				self:UpdateAuras(unit, frame)
			end
		end
	end
end

local function buffFrame_OnUpdate(this)
	if GameTooltip:IsOwned(this) then
		if this.player then
			local id = GetPlayerBuff(this.id, "HELPFUL")
			GameTooltip:SetPlayerBuff(id, "HELPFUL")
		else
			GameTooltip:SetUnitBuff(this.unit, this.id, 0)
		end
	else
		PitBull_Aura:CancelScheduledEvent("PitBull_Aura-buffFrame-Update")
	end
end

local function buffFrame_OnEnter(this)
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
	GameTooltip.owner = this
	if this.player then
		local id = GetPlayerBuff(this.id, "HELPFUL")
		GameTooltip:SetPlayerBuff(id, "HELPFUL")
	else
		GameTooltip:SetUnitBuff(this.unit, this.id, 0)
	end
	PitBull_Aura:ScheduleRepeatingEvent("PitBull_Aura-buffFrame-Update", buffFrame_OnUpdate, 0.2, this)
end

local function debuffFrame_OnUpdate(this)
	if GameTooltip:IsOwned(this) then
		if this.player then
			local id = GetPlayerBuff(this.id, "HARMFUL")
			GameTooltip:SetPlayerBuff(id, "HARMFUL")
		else
			GameTooltip:SetUnitDebuff(this.unit, this.id, 0)
		end
	else
		PitBull_Aura:CancelScheduledEvent("PitBull_Aura-debuffFrame-Update")
	end
end

local function debuffFrame_OnEnter(this)
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")
	GameTooltip.owner = this
	if this.player then
		local id = GetPlayerBuff(this.id, "HARMFUL")
		GameTooltip:SetPlayerBuff(id, "HARMFUL")
	else
		GameTooltip:SetUnitDebuff(this.unit, this.id, 0)
	end
	PitBull_Aura:ScheduleRepeatingEvent("PitBull_Aura-debuffFrame-Update", debuffFrame_OnUpdate, 0.2, this)
end

local function buffFrame_OnLeave(this)
	if GameTooltip:IsOwned(this) then
		PitBull_Aura:CancelScheduledEvent("PitBull_Aura-buffFrame-Update")
		PitBull_Aura:CancelScheduledEvent("PitBull_Aura-debuffFrame-Update")
		GameTooltip:Hide()
	end
end
local debuffFrame_OnLeave = buffFrame_OnLeave

local aurasNeedTextUpdate = {}

local math_ceil = math.ceil
local HOUR_ONELETTER_ABBR = HOUR_ONELETTER_ABBR:gsub(" ", "") -- "%dh"
local MINUTE_ONELETTER_ABBR = MINUTE_ONELETTER_ABBR:gsub(" ", "") -- "%dm"
local function formatTime(seconds)
	if seconds >= 3600 then
		local hours = math_ceil(seconds/3600)
		return HOUR_ONELETTER_ABBR:format(hours)
	elseif seconds >= 180 then
		local minutes = math_ceil(seconds/60)
		return MINUTE_ONELETTER_ABBR:format(seconds/60)
	elseif seconds > 60 then
		seconds = math_ceil(seconds)
		return ("%d:%d"):format(seconds/60, seconds%60)
	else
		return ("%d"):format(math_ceil(seconds))
	end
end

function PitBull_Aura:UpdateAuraFrameTexts()
	if not self.db.profile.cooldownText then
		return
	end
	local now = GetTime()
	for frame in pairs(aurasNeedTextUpdate) do
		frame.cooldownText:SetText(formatTime(frame.cooldownTimeTillDone - now))
	end
end

local buffsort_isfriend
local function buffsort(a, b)
	-- num, name, texture, applications, duration, timeLeft
	if not a then
		return false
	elseif not b then
		return true
	end
	
	-- sort by name
	local a_name, b_name = a[2], b[2]
	if a_name ~= b_name then
		if not a_name then
			return false
		elseif not b_name then
			return true
		end
		if buffsort_isfriend then
			local a_mybuff = (selfBuffs[a_name] or friendBuffs[a_name] or petBuffs[a_name])
			local b_mybuff = (selfBuffs[b_name] or friendBuffs[b_name] or petBuffs[b_name])
			if not a_mybuff ~= not b_mybuff then
				if a_mybuff then
					return true
				else
					return false
				end
			end
		end
		return a_name < b_name
	end
	
	-- show your own buffs first
	local a_timeLeft, b_timeLeft = a[6], b[6]
	if not a_timeLeft ~= not b_timeLeft then
		if a_timeLeft then
			return true
		else
			return false
		end
	end
	
	-- keep ID order
	local a_id, b_id = a[1], b[1]
	if not a_id then
		return false
	elseif not b_id then
		return true
	end
	return a_id < b_id
end

local debuffsort_isfriend
local function debuffsort(a, b)
	-- num, name, texture, applications, dispelType, duration, timeLeft
	if not a then
		return false
	elseif not b then
		return true
	end
	if debuffsort_isfriend then
		-- sort by dispel type
		local a_dispelType, b_dispelType = a[5], b[5]
		if a_dispelType ~= b_dispelType then
			if not a_dispelType then
				return false
			elseif not b_dispelType then
				return true
			end	
			return a_dispelType < b_dispelType
		end
	end
	
	-- sort by name
	local a_name, b_name = a[2], b[2]
	if a_name ~= b_name then
		if not a_name then
			return false
		elseif not b_name then
			return true
		end
		if not debuffsort_isfriend then
			local a_mydebuff = enemyDebuffs[a_name]
			local b_mydebuff = enemyDebuffs[b_name]
			if not a_mydebuff ~= not b_mydebuff then
				if a_mydebuff then
					return true
				else
					return false
				end
			end
		else
			local a_mydebuff = friendDebuffs[a_name] or selfDebuffs[a_name]
			local b_mydebuff = friendDebuffs[b_name] or selfDebuffs[b_name]
			if not a_mydebuff ~= not b_mydebuff then
				if a_mydebuff then
					return true
				else
					return false
				end
			end
		end
		return a_name < b_name
	end
	
	-- show your own buffs first
	local a_timeLeft, b_timeLeft = a[7], b[7]
	if not a_timeLeft ~= not b_timeLeft then
		if a_timeLeft then
			return true
		else
			return false
		end
	end
	
	-- keep ID order
	local a_id, b_id = a[1], b[1]
	if not a_id then
		return false
	elseif not b_id then
		return true
	end
	return a_id < b_id
end

local PlayerBuffDurations = setmetatable({}, {__index=function(self,key)
	for i = 1, 40 do
		local name, _, texture, applications, duration, timeLeft = UnitBuff("player", i)
		if not texture then
			break
		end
		if name == key then
			self[key] = duration
			return duration
		end
	end
end})

local function UpdateBuffs(unit, frame)
	local auraFrame = frame.auraFrame

	local db = PitBull_Aura.db.profile[frame.group]

	local split = db.split
	local raidFilter = db.filter
	local size = db.buffsize
	local maxbuffs = db.maxbuffs

	local buffs = auraFrame.buffs or new()
	local max_buffs_perrow = math_floor(auraFrame:GetWidth() / size)
	local scale_adjust = auraFrame:GetWidth() / (size * max_buffs_perrow)
	local font, fontsize = PitBull:GetFont()
	
	if db.snap then
		size = size * scale_adjust
	end
	
	local player = UnitIsUnit(unit, "player")
	local pet = not player and UnitIsUnit(unit, "pet")
	local isfriend = not pet and UnitIsFriend("player", unit)
	local list = new()
	for num = 1, maxbuffs do
		local name, _, texture, applications, duration, timeLeft
		local good = true
		if player then
			local id = GetPlayerBuff(num, "HELPFUL")
			if id > 0 then
				name, texture, applications, timeLeft = GetPlayerBuffName(id), GetPlayerBuffTexture(id), GetPlayerBuffApplications(id), GetPlayerBuffTimeLeft(id)
				duration = PlayerBuffDurations[name]
				if not duration or timeLeft > duration then
					duration = timeLeft
					PlayerBuffDurations[name] = timeLeft
				end
				if texture and raidFilter then
					if not selfBuffs[name] and not friendBuffs[name] then
						good = false
					end
				end
			end
		elseif pet then
			name, _, texture, applications, duration, timeLeft = UnitBuff(unit, num, 0)
			if texture and raidFilter then
				if not petBuffs[name] and not friendBuffs[name] then
					good = false
				end
			end
		elseif isfriend then
			name, _, texture, applications, duration, timeLeft = UnitBuff(unit, num, 0)
			if texture and raidFilter then
				if not friendBuffs[name] then
					good = false
				end
			end
		else
			name, _, texture, applications, duration, timeLeft = UnitBuff(unit, num, 0)
		end
		if (texture and good) or configMode then
			list[#list + 1] = new(num, name, texture, applications, duration, timeLeft)
		end
	end
	
	if db.sort then
		buffsort_isfriend = player or pet or isfriend
		table_sort(list, buffsort)
	end
	
	for i = maxbuffs+1, #list do
		list[i] = del(list[i])
	end

	for j = #buffs, #list+1, -1 do
		local v = buffs[j]
		buffs[j] = nil
		if v.text then
			v.text = delFrame(v.text)
		end
		if v.border then
			v.border = delFrame(v.border)
		end
		if v.cooldownText then
			aurasNeedTextUpdate[v] = nil
			v.cooldownText = delFrame(v.cooldownText)
		end
		if v.cooldown then
			v.cooldown.startCooldownTime = nil
			v.cooldown = delFrame(v.cooldown)
		end
		v.icon = delFrame(v.icon)
		v.unit = nil
		v.id = nil
		v.name = nil
		v.player = nil
		v:SetScript("OnEnter", nil)
		v:SetScript("OnLeave", nil)
		if GameTooltip.owner == v then
			buffFrame_OnLeave(v)
		end
		delFrame(v)
	end
	
	for i, v in ipairs(list) do
		local buffFrame = buffs[i]
		local text, icon
		if not buffFrame then
			buffFrame = newFrame("Button", auraFrame)
			buffs[i] = buffFrame
		
			icon = newFrame("Texture", buffFrame, "BACKGROUND")
			buffFrame.icon = icon
			icon:ClearAllPoints()
			icon:SetAllPoints(buffFrame)
		else
			text = buffFrame.text
			icon = buffFrame.icon
		end
		
		local texture = v[3]
		icon:SetTexture(texture)
		
		local applications = v[4]
		if not applications or applications <= 1 then
			if text then
				buffFrame.text = delFrame(text)
				text = nil
			end
		else
			if not text then
				text = newFrame("FontString", buffFrame, "OVERLAY")
				buffFrame.text = text
				text:SetFont( font, fontsize, "OUTLINE" )
				text:SetShadowColor(0, 0, 0, 1)
				text:SetShadowOffset(0.8, -0.8)
				text:ClearAllPoints()
				text:SetPoint("BOTTOMRIGHT", buffFrame, "BOTTOMRIGHT", 0, 0)
			end
			text:SetText(applications)
		end
		if db.highlight.Buffs or (not texture and configMode) then
			local border = buffFrame.border
			if not border then
				border = newFrame("Texture", buffFrame, "BORDER")
				buffFrame.border = border
				border:SetTexture(border_path)
				border:SetVertexColor(unpack(self.db.profile.colors.buffs))
				border:ClearAllPoints()
				border:SetAllPoints(buffFrame)
			end
		else
			if buffFrame.border then
				buffFrame.border = delFrame(buffFrame.border)
			end
		end

		if texture then
			buffFrame:SetScript("OnEnter", buffFrame_OnEnter)
			buffFrame:SetScript("OnLeave", buffFrame_OnLeave)
			buffFrame.id = v[1]
			buffFrame.player = player
			buffFrame.unit = unit
			buffFrame.name = v[2]
			
			local duration = v[5]
			if duration and duration > 0 then
				if self.db.profile.cooldownText then
					if not buffFrame.cooldownText then
						local text = newFrame("FontString", buffFrame, "OVERLAY")
						buffFrame.cooldownText = text
						aurasNeedTextUpdate[buffFrame] = true
						text:SetAlpha(self.db.profile.cooldownTextAlpha)
						text:SetFont(font, fontsize * 0.8, "OUTLINE")
						text:SetShadowColor(0, 0, 0, 1)
						text:SetShadowOffset(0.8, -0.8)
						text:ClearAllPoints()
						text:SetPoint("TOP", buffFrame, "TOP", 0, 0)
					end
					local timeLeft = v[6]
					buffFrame.cooldownTimeTillDone = GetTime() + timeLeft
					buffFrame.cooldownText:SetText(formatTime(timeLeft))
				else
					if buffFrame.cooldownText then
						aurasNeedTextUpdate[buffFrame] = nil
						buffFrame.cooldownText = delFrame(buffFrame.cooldownText)
					end
				end
				if self.db.profile.cooldown then
					local cooldown = buffFrame.cooldown
					if not cooldown then
						cooldown = newFrame("Cooldown", buffFrame)
						if WoW21 then
							cooldown:SetReverse(true)
						end
						buffFrame.cooldown = cooldown
						cooldown:SetAllPoints(buffFrame)
					end
					local timeLeft = v[6]
					local startCooldownTime = GetTime() + timeLeft - duration
					cooldown:SetCooldown(startCooldownTime, duration)
				else	
					if buffFrame.cooldown then
						buffFrame.cooldown.startCooldownTime = nil
						buffFrame.cooldown = delFrame(buffFrame.cooldown)
					end
				end
			else
				if buffFrame.cooldownText then
					aurasNeedTextUpdate[buffFrame] = nil
					buffFrame.cooldownText = delFrame(buffFrame.cooldownText)
				end
				if buffFrame.cooldown then
					buffFrame.cooldown.startCooldownTime = nil
					buffFrame.cooldown = delFrame(buffFrame.cooldown)
				end
			end
		else
			if not text then
				text = newFrame("FontString", buffFrame, "OVERLAY")
				buffFrame.text = text
				text:SetFont( font, fontsize, "OUTLINE" )
				text:SetShadowColor(0, 0, 0, 1)
				text:SetShadowOffset(0.8, -0.8)
				text:ClearAllPoints()
				text:SetPoint("BOTTOMRIGHT", buffFrame, "BOTTOMRIGHT", 0, 0)
			end
			text:SetText("X")
			if buffFrame.cooldownText then
				aurasNeedTextUpdate[buffFrame] = nil
				buffFrame.cooldownText = delFrame(buffFrame.cooldownText)
			end
			if buffFrame.cooldown then
				buffFrame.cooldown.startCooldownTime = nil
				buffFrame.cooldown = delFrame(buffFrame.cooldown)
			end
		end
		if buffFrame.cooldown then
			if text then
				text:SetParent(buffFrame.cooldown)
			end
			if buffFrame.cooldownText then
				buffFrame.cooldownText:SetParent(buffFrame.cooldown)
			end
		else
			if text then
				text:SetParent(buffFrame)
			end
			if buffFrame.cooldownText then
				buffFrame.cooldownText:SetParent(buffFrame)
			end
		end
		list[i] = del(v)
	end
	list = del(list)
	local num_buffs = #buffs
	
	local row = 1
	local lastrow = 1
	
	local direction = db.buffdirection
	for i = 1, num_buffs do
		local buff = buffs[i]
		buff:Show()
		buff:ClearAllPoints()
		-- Workaround, find and fix invalid sizes.
		buff:SetWidth(size)
		buff:SetHeight(size)
		if split then
			if direction == "Up then Left" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * (row - 1) * size, ((i-1) % max_buffs_perrow) * size)
			elseif direction == "Up then Right" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", (row - 1) * size, ((i-1) % max_buffs_perrow) * size)
			elseif direction == "Down then Left" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * (row - 1) * size, -1 * ((i-1) % max_buffs_perrow) * size)
			elseif direction == "Down then Right" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", (row - 1) * size, -1 * ((i-1) % max_buffs_perrow) * size)
			elseif direction == "Left then Up" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * ((i-1) % max_buffs_perrow) * size, (row - 1) * size)
			elseif direction == "Left then Down" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * ((i-1) % max_buffs_perrow) * size, -1 * (row - 1) * size)
			elseif direction == "Right then Up" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_buffs_perrow) * size, (row - 1) * size)
			elseif direction == "Right then Down" then
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_buffs_perrow) * size, -1 * (row - 1) * size)
			end
		else
			if db.flip then
				buff:SetPoint("TOPRIGHT", auraFrame, "TOPRIGHT", ((i-1) % max_buffs_perrow) * -1 * size, (row - 1) * self.db.profile[frame.group].grow * size)
			else
				buff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_buffs_perrow) * size, (row - 1) * self.db.profile[frame.group].grow * size)
			end
		end
		lastrow = row
		if i % max_buffs_perrow == 0 then
			row = row + 1
		end
	end
	
	if num_buffs == 0 then
		buffs = del(buffs)
	end
	if not split then
		auraFrame:SetHeight(lastrow * size)
	end
	auraFrame.buffs = buffs
	auraFrame.num_shown_buffs = num_buffs
end

local PlayerDebuffDurations = setmetatable({}, {__index=function(self,key)
	for i = 1, 40 do
		local name, _, texture, applications, dispelType, duration, timeLeft = UnitDebuff("player", i)
		if not texture then
			break
		end
		if name == key then
			self[key] = duration
			return duration
		end
	end
end})

local function UpdateDebuffs(unit, frame, buffs)
	local db = PitBull_Aura.db.profile[frame.group]
	
	local split = db.split
	
	local auraFrame = split and frame.auraFrame2 or frame.auraFrame

	local snap = db.snap
	local raidFilter = db.filter
	local size = db.debuffsize

	local auraFrame_width = auraFrame:GetWidth()
	local max_debuffs_perrow = math_floor(auraFrame_width / size)
	local scale_adjust = auraFrame_width / (size * max_debuffs_perrow)
	local font, fontsize = PitBull:GetFont()
	
	if snap then
		size = size * scale_adjust
	end
	
	local debuffs = auraFrame.debuffs or new()
	
	local maxdebuffs = db.maxdebuffs
	
	local player = UnitIsUnit(unit, "player")
	local pet = not player and UnitIsUnit(unit, "pet")
	local isfriend = not pet and UnitIsFriend("player", unit)
	local list = new()
	for num = 1, maxdebuffs do
		local name, _, texture, applications, dispelType, duration, timeLeft
		local good = true
		if player then
			local id = GetPlayerBuff(num, "HARMFUL")
			if id > 0 then
				name, texture, applications, dispelType, timeLeft = GetPlayerBuffName(id), GetPlayerBuffTexture(id), GetPlayerBuffApplications(id), GetPlayerBuffDispelType(id), GetPlayerBuffTimeLeft(id)
				duration = PlayerDebuffDurations[name]
				if not duration or timeLeft > duration then
					duration = timeLeft
					PlayerDebuffDurations[name] = timeLeft
				end
				if texture and raidFilter then
					if not canDispel[dispelType] and not selfDebuffs[name] and not friendDebuffs[name] then
						good = false
					end
				end
			end
		elseif pet then
			name, _, texture, applications, dispelType, duration, timeLeft = UnitDebuff(unit, num, 0)
			if texture and raidFilter then
				if not canDispel[dispelType] and not petDebuffs[name] and not friendDebuffs[name] then
					good = false
				end
			end
		elseif isfriend then
			name, _, texture, applications, dispelType, duration, timeLeft = UnitDebuff(unit, num, 0)
			if texture and raidFilter then
				if not canDispel[dispelType] and not friendDebuffs[name] then
					good = false
				end
			end
		else
			name, _, texture, applications, dispelType, duration, timeLeft = UnitDebuff(unit, num, 0)
			if texture and raidFilter then
				if not enemyDebuffs[name] then
					good = false
				end
			end
		end
		
		if (texture and good) or configMode then
			list[#list + 1] = new(num, name, texture, applications, dispelType, duration, timeLeft)
		end
	end

	if db.sort then
		debuffsort_isfriend = player or pet or isfriend
		table_sort(list, debuffsort)
	end
	
	for i = maxdebuffs+1, #list do
		list[i] = del(list[i])
	end
	
	for j = #debuffs, #list+1, -1 do
		local v = debuffs[j]
		debuffs[j] = nil
		if v.text then
			v.text = delFrame(v.text)
		end
		if v.border then
			v.border = delFrame(v.border)
		end
		if v.cooldownText then
			aurasNeedTextUpdate[v] = nil
			v.cooldownText = delFrame(v.cooldownText)
		end
		if v.cooldown then
			v.cooldown.startCooldownTime = nil
			v.cooldown = delFrame(v.cooldown)
		end
		v.icon = delFrame(v.icon)
		v.unit = nil
		v.id = nil
		v.name = nil
		v.dispelType = nil
		v.player = nil
		v:SetScript("OnEnter", nil)
		v:SetScript("OnLeave", nil)
		if GameTooltip.owner == v then
			debuffFrame_OnLeave(v)
		end
		delFrame(v)
	end
	
	for i, v in ipairs(list) do
		local num, name, texture, applications, dispelType, duration, timeLeft = unpack(v)
		list[i] = del(v)
		local debuffFrame, text, icon = debuffs[i]
		if not debuffFrame then
			debuffFrame = newFrame("Button", auraFrame)
			debuffs[i] = debuffFrame
		
			icon = newFrame("Texture", debuffFrame, "BACKGROUND")
			debuffFrame.icon = icon
			icon:ClearAllPoints()
			icon:SetAllPoints(debuffFrame)
		else
			text = debuffFrame.text 
			icon = debuffFrame.icon
		end
		
		icon:SetTexture(texture)
	
		if not applications or applications <= 1 then
			if text then
				debuffFrame.text = delFrame(text)
				text = nil
			end
		else
			if not text then
				text = newFrame("FontString", debuffFrame, "OVERLAY")
				debuffFrame.text = text
				text:SetFont( font, fontsize, "OUTLINE" )
				text:SetShadowColor(0, 0, 0, 1)
				text:SetShadowOffset(0.8, -0.8)
				text:ClearAllPoints()
				text:SetPoint("BOTTOMRIGHT", debuffFrame, "BOTTOMRIGHT", 0, 0)	
			end
			text:SetText(applications)
		end
		if db.highlight.Debuffs or (configMode and not texture) then
			local border = debuffFrame.border
			if not border then
				border = newFrame("Texture", debuffFrame, "BORDER")
				debuffFrame.border = border
				border:ClearAllPoints()
				border:SetAllPoints(debuffFrame)
				border:SetTexture(border_path)
			end
			if PitBull_Aura.db.profile[frame.group].highlightType then
				border:SetVertexColor(unpack(self.db.profile.colors.debuffs[dispelType or "nil"]))
			else
				border:SetVertexColor(unpack(self.db.profile.colors.debuffs["nil"]))
			end
		else
			if debuffFrame.border then
				debuffFrame.border = delFrame(debuffFrame.border)
			end
		end

		if texture then
			debuffFrame:SetScript("OnEnter", debuffFrame_OnEnter)
			debuffFrame:SetScript("OnLeave", debuffFrame_OnLeave)
			debuffFrame.id = num
			debuffFrame.unit = unit
			debuffFrame.player = player
		
			debuffFrame.dispelType = dispelType
			debuffFrame.name = name
			
			if duration and duration > 0 then
				if self.db.profile.cooldownText then
					if not debuffFrame.cooldownText then
						local text = newFrame("FontString", debuffFrame, "OVERLAY")
						debuffFrame.cooldownText = text
						aurasNeedTextUpdate[debuffFrame] = true
						text:SetAlpha(self.db.profile.cooldownTextAlpha)
						text:SetFont(font, fontsize * 0.8, "OUTLINE")
						text:SetShadowColor(0, 0, 0, 1)
						text:SetShadowOffset(0.8, -0.8)
						text:ClearAllPoints()
						text:SetPoint("TOP", debuffFrame, "TOP", 0, 0)
					end
					debuffFrame.cooldownTimeTillDone = GetTime() + timeLeft
					debuffFrame.cooldownText:SetText(formatTime(timeLeft))
				else
					if debuffFrame.cooldownText then
						aurasNeedTextUpdate[debuffFrame] = nil
						debuffFrame.cooldownText = delFrame(debuffFrame.cooldownText)
					end
				end
				if self.db.profile.cooldown then
					local cooldown = debuffFrame.cooldown
					if not cooldown then
						cooldown = newFrame("Cooldown", debuffFrame)
						if WoW21 then
							cooldown:SetReverse(true)
						end
						debuffFrame.cooldown = cooldown
						cooldown:SetAllPoints(debuffFrame)
					end
					local startCooldownTime = GetTime() - duration + timeLeft
					cooldown:SetCooldown(startCooldownTime, duration)
				else
					if debuffFrame.cooldown then
						debuffFrame.cooldown.startCooldownTime = nil
						debuffFrame.cooldown = delFrame(debuffFrame.cooldown)
					end
				end
			else	
				if debuffFrame.cooldownText then
					aurasNeedTextUpdate[debuffFrame] = nil
					debuffFrame.cooldownText = delFrame(debuffFrame.cooldownText)
				end
				if debuffFrame.cooldown then
					debuffFrame.cooldown.startCooldownTime = nil
					debuffFrame.cooldown = delFrame(debuffFrame.cooldown)
				end
			end
		else
			debuffFrame.name = ''
			if not text then
				text = newFrame("FontString", debuffFrame, "OVERLAY")
				debuffFrame.text = text
				text:SetFont( font, fontsize, "OUTLINE" )
				text:SetShadowColor(0, 0, 0, 1)
				text:SetShadowOffset(0.8, -0.8)
				text:ClearAllPoints()
				text:SetPoint("BOTTOMRIGHT", debuffFrame, "BOTTOMRIGHT", 0, 0)
			end
			text:SetText("X")
			if debuffFrame.cooldownText then
				aurasNeedTextUpdate[debuffFrame] = nil
				debuffFrame.cooldownText = delFrame(debuffFrame.cooldownText)
			end
			if debuffFrame.cooldown then
				debuffFrame.cooldown.startCooldownTime = nil
				debuffFrame.cooldown = delFrame(debuffFrame.cooldown)
			end
		end
		if debuffFrame.cooldown then
			if text then
				text:SetParent(debuffFrame.cooldown)
			end
			if debuffFrame.cooldownText then
				debuffFrame.cooldownText:SetParent(debuffFrame.cooldown)
			end
		else
			if text then
				text:SetParent(debuffFrame)
			end
			if debuffFrame.cooldownText then
				debuffFrame.cooldownText:SetParent(debuffFrame)
			end
		end
	end
	list = del(list)

	local num_debuffs = #debuffs
	
	if split then
		-- note that this is the top row that we"ll be using for the first few debuffs.  split mode they descend, nonsplit they ascend
		local direction = db.debuffdirection
		local row = 1
		for i = 1, num_debuffs do
			local debuff = debuffs[i]
			debuff:Show()
			debuff:SetBackdropBorderColor(1,0,0)
			debuff:ClearAllPoints()
			-- Workaround, find and fix invalid sizes.
			debuff:SetWidth(size)
			debuff:SetHeight(size)
			if direction == "Up then Left" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * (row - 1) * size, ((i-1) % max_debuffs_perrow) * size)
			elseif direction == "Up then Right" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", (row - 1) * size, ((i-1) % max_debuffs_perrow) * size)
			elseif direction == "Down then Left" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * (row - 1) * size, -1 * ((i-1) % max_debuffs_perrow) * size)
			elseif direction == "Down then Right" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", (row - 1) * size, -1 * ((i-1) % max_debuffs_perrow) * size)
			elseif direction == "Left then Up" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * ((i-1) % max_debuffs_perrow) * size, (row - 1) * size)
			elseif direction == "Left then Down" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", -1 * ((i-1) % max_debuffs_perrow) * size, -1 * (row - 1) * size)
			elseif direction == "Right then Up" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_debuffs_perrow) * size, (row - 1) * size)
			elseif direction == "Right then Down" then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_debuffs_perrow) * size, -1 * (row - 1) * size)
			end
			if i % max_debuffs_perrow == 0 then
				row = row + 1
			end
		end
	else
		local buffsize = db.buffsize
		
		if snap then
			buffsize = buffsize * scale_adjust
		end
		
		local max_buffs_perrow = math_floor(auraFrame_width / buffsize)
		local num_buffs = auraFrame.num_shown_buffs or 0
		
		local num_buffs_bottomrow = num_buffs % max_buffs_perrow
		local num_debuffs_toprow = num_debuffs % max_debuffs_perrow
		
		local colliding = (num_debuffs_toprow * size + num_buffs_bottomrow * buffsize) > auraFrame_width
		
		-- start at the bottom full row of buffs
		local offset = math_floor(num_buffs / max_buffs_perrow) * buffsize +
		-- if colliding, push it down the sum of the values
		(colliding and (buffsize + size) or 0) +
		-- if sharing a row, push it down the larger value.
		((not colliding and num_debuffs_toprow > 0 and num_buffs_bottomrow > 0) and (buffsize > size and buffsize or size) or 0) +
		-- if one row"s full and the other isnt, push it the pertaining value.
		((num_debuffs_toprow == 0 and num_buffs_bottomrow > 0) and buffsize or 0) +
		((num_debuffs_toprow > 0 and num_buffs_bottomrow == 0) and size or 0)
		
		local flip = db.flip
		local grow = db.grow

		offset = grow == 1 and offset - buffsize + size or grow * offset
		
		-- note that this will be the bottom row that we draw debuffs on.
		local row = math_floor(num_debuffs / max_debuffs_perrow)
		for i = 1, num_debuffs do
			local debuff = debuffs[i]
			debuff:Show()
			debuff:SetBackdropBorderColor(1,0,0)
			debuff:ClearAllPoints()
			-- Workaround, find and fix invalid sizes.
			debuff:SetWidth(size)
			debuff:SetHeight(size)
			if (flip and buffs) or (not flip and not buffs) then
				debuff:SetPoint("TOPLEFT", auraFrame, "TOPLEFT", ((i-1) % max_debuffs_perrow) * size, (row - 1) * grow * size + offset)
			else
				debuff:SetPoint("TOPRIGHT", auraFrame, "TOPRIGHT", ((i-1) % max_debuffs_perrow) * -1 * size, (row - 1) * grow * size + offset)
			end
			if i % max_debuffs_perrow == 0 then
				row = row - 1
			end
		end
	end
	
	if num_debuffs == 0 then
		debuffs = del(debuffs)
	end
	
	auraFrame.debuffs = debuffs
end

local function UpdateFrameHighlight(unit, frame)
	local frameHighlight = PitBull_Aura.db.profile[frame.group].frameHighlight
	
	local htexture, hdispel, hashighlight, checkagain
	
	if frameHighlight == "Never" or ((frameHighlight == "Cureable by me" or frameHighlight == "Cureable") and not UnitIsFriend("player", unit)) then
	else
		for i = 1, 40 do
			if not hashighlight or hashighlight == "nil" or checkagain then -- if hashighlight is "nil" we keep trying there might be a curable debuff we prioritize those for highlighting
				local _
				_, _, htexture, _, hdispel = UnitDebuff(unit, i, 0) -- ignore the raidfilter for frame highlighting
				if htexture then
					if not hdispel then -- no dispel type set
						if frameHighlight == "All Debuffs" then -- only set highlight to "nil"  if we want to show all debuffs
							hashighlight = "nil" -- we specifically continue here to find an optional cureable or cureable by me debuff which has priority for highlighting
						end
					elseif frameHighlight == "Cureable" or frameHighlight == "All Debuffs" then
						if canDispel and canDispel[hdispel] then
							hashighlight = hdispel
							break -- break here, we"ve got a cureable by me debuff...
						else
							hashighlight = hdispel -- continue here to try and find a cureable by me debuff.
						end
					elseif frameHighlight == "Cureable by me" and canDispel and canDispel[hdispel] then
						hashighlight = hdispel
						break -- break here, we"ve got a cureable by me debuff...
					end
				else
					break
				end
			end
		end
	end
	
	if hashighlight then
		local style = PitBull_Aura.db.profile[frame.group].highlightStyle
		if style == "border" then
			frame.debuffhighlight:SetTexture(debuffHighlightBorder_path)
		else
			frame.debuffhighlight:SetTexture(debuffHighlight_path)
		end
		frame.debuffhighlight:SetBlendMode("ADD")
		frame.debuffhighlight:SetAlpha(0.75)
		local r,g,b = unpack(self.db.profile.colors.debuffs[hashighlight])
		frame.debuffhighlight:SetVertexColor(r,g,b)
		frame.debuffhighlight:Show()
	else
		frame.debuffhighlight:Hide()
	end
	
end

function PitBull_Aura:UpdateAuras(unit, frame)
	if self.db.profile[frame.group].frameHighlight == "Never" then
		frame.debuffhighlight:Hide()
	else
		UpdateFrameHighlight(unit, frame)
	end
	if not unitsShown[frame] or self.db.profile[frame.group].hidden then
		return
	end
	local buffs
	if not self.db.profile[frame.group].hiddenBuffs then
		buffs = true
		UpdateBuffs(unit, frame)
	end
	if not self.db.profile[frame.group].hiddenDebuffs then
		UpdateDebuffs(unit, frame, buffs)
	end
end

do
	local framedelay = setmetatable({}, {__index = function(t,k)
		t[k] = 0
		return t[k]
	end})
	function PitBull_Aura:OnUpdateFrame(unit, frame)
		if not frame.auraFrame or self.db.profile[frame.group].hidden or not unitsShown[frame] then
			return
		end
		if IsWackyUnit[unit] then
			local time = GetTime()
			if time - framedelay[frame] > 0.5 then
				self:UpdateAuras(unit, frame)
				framedelay[frame] = time
			end
		else
			self:UpdateAuras(unit,frame)
		end
	end
end

function PitBull_Aura:OnPopulateUnitFrame(unit, frame)
	frame.auraFrame = newFrame("Frame", frame)
	if self.db.profile.split then
		frame.auraFrame2 = newFrame("Frame", frame)
	end
	local highlight = newFrame("Texture", frame.overlay, "OVERLAY")
	frame.debuffhighlight = highlight
	local style = self.db.profile[frame.group].highlightStyle
	if style == "border" then
		frame.debuffhighlight:SetTexture(debuffHighlightBorder_path)
	else
		frame.debuffhighlight:SetTexture(debuffHighlight_path)
	end
	highlight:SetBlendMode("ADD")
	highlight:SetAlpha(0.75)
	highlight:Hide()
	highlight:SetAllPoints(frame)
end

function PitBull_Aura:OnUpdateFont(font, fontsize)
	for unit,frame in PitBull:IterateUnitFrames() do
		self:ClearAuras(unit, frame)
		self:UpdateAuras(unit, frame)
	end
end

function PitBull_Aura:ClearAuras(unit, frame)
	if not frame.auraFrame then
		AceLibrary("AceConsole-2.0"):Print("Error occurred, please inform ckknight:", debugstack())
		return
	end
	local buffs = frame.auraFrame.buffs
	if buffs then
		for i = 1, #buffs do
			local v = buffs[i]
			buffs[i] = nil
			if v.text then
				v.text = delFrame(v.text)
			end
			v.icon = delFrame(v.icon)
			if v.border then
				v.border = delFrame(v.border)
			end
			v.unit = nil
			v.id = nil
			v:SetScript("OnEnter", nil)
			v:SetScript("OnLeave", nil)
			if GameTooltip.owner == v then
				buffFrame_OnLeave(v)
			end
			delFrame(v)
		end
		frame.auraFrame.buffs = del(buffs)
	end
	
	local split = self.db.profile[frame.group].split
	local debuffs
	if split then
		debuffs = frame.auraFrame2.debuffs
	else
		debuffs = frame.auraFrame.debuffs
	end
	if debuffs then
		for i = 1, #debuffs do
			local v = debuffs[i]
			debuffs[i] = nil
			if v.text then
				v.text = delFrame(v.text)
			end
			v.icon = delFrame(v.icon)
			if v.border then
				v.border = delFrame(v.border)
			end
			v.unit = nil
			v.id = nil
			v:SetScript("OnEnter", nil)
			v:SetScript("OnLeave", nil)
			if GameTooltip.owner == v then
				debuffFrame_OnLeave(v)
			end
			delFrame(v)
		end
		if split then
			frame.auraFrame2.debuffs = del(debuffs)
		else
			frame.auraFrame.debuffs = del(debuffs)
		end
	end
end

function PitBull_Aura:OnClearUnitFrame(unit, frame)
	if frame.auraFrame then
		self:ClearAuras(unit, frame)
	
		frame.auraFrame = delFrame(frame.auraFrame)
		if frame.auraFrame2 then
			frame.auraFrame2 = delFrame(frame.auraFrame2)
		end
	end
	if frame.debuffhighlight then
		frame.debuffhighlight = delFrame(frame.debuffhighlight)
	end
	unitsShown[frame] = nil
end

function PitBull_Aura:OnUnknownLayout(unit, frame, name)
	if name == "auraFrame" then
		frame.auraFrame:SetHeight(self.db.profile[frame.group].buffsize)
		frame.auraFrame:SetPoint("TOPLEFT", frame, "BOTTOMLEFT")
		frame.auraFrame:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT")
	elseif name == "auraFrame2" then
		frame.auraFrame2:SetHeight(self.db.profile[frame.group].debuffsize)
		frame.auraFrame2:SetPoint("TOPLEFT", frame.auraFrame, "BOTTOMLEFT")
		frame.auraFrame2:SetPoint("TOPRIGHT", frame.auraFrame, "BOTTOMRIGHT")
	elseif name == "debuffhighlight" then
		frame.debuffhighlight:SetBlendMode("ADD")
		frame.debuffhighlight:SetAlpha(0.75)
		frame.debuffhighlight:SetAllPoints( frame )
		frame.debuffhighlight:Hide()
	end
end
function PitBull_Aura:OnUpdateLayout(unit, frame)
	local now = not frame.auraFrame or not frame.auraFrame:IsShown()
	unitsShown[frame] = not now
	if now then
		self:ClearAuras(unit, frame)
	else
		self:UpdateAuras(unit, frame)
	end
end

function PitBull_Aura:OnChangeConfigMode(value)
	configMode = value
	for unit, frame in PitBull:IterateUnitFrames() do
		self:UpdateAuras(unit, frame)
	end
end

local function updategroup(group)
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnClearUnitFrame(unit, frame)
		PitBull_Aura:OnPopulateUnitFrame(unit, frame)
		unitsShown[frame] = false
		PitBull:UpdateLayout(frame)
	end
end

local function getSplit(group)
	return PitBull_Aura.db.profile[group].split
end

local function setSplit(group, value)
	PitBull_Aura.db.profile[group].split = value
	updategroup(group)
end

local function getSnap(group)
	return PitBull_Aura.db.profile[group].snap
end

local function setSnap(group, value)
	PitBull_Aura.db.profile[group].snap = value
	updategroup(group)
end

local function getSort(group)
	return PitBull_Aura.db.profile[group].sort
end

local function setSort(group, value)
	PitBull_Aura.db.profile[group].sort = value
	updategroup(group)
end

local function getAllOrBuffHidden(group)
	return PitBull_Aura.db.profile[group].hidden or PitBull_Aura.db.profile[group]["hiddenBuffs"]
end
local function getAllOrDebuffHidden(group)
	return PitBull_Aura.db.profile[group].hidden or PitBull_Aura.db.profile[group]["hiddenDebuffs"]
end

local function getHidden(group)
	return PitBull_Aura.db.profile[group].hidden
end

local function setHidden(group, value)
	PitBull_Aura.db.profile[group].hidden = value
	updategroup(group)
end


local function getMultiHidden(table)
	local group, type = table.group, table.type
	return PitBull_Aura.db.profile[group]["hidden"..type]
end

local function setMultiHidden(table, value)
	local group, type = table.group, table.type
	PitBull_Aura.db.profile[group]["hidden"..type] = value
	updategroup(group)
end

local function getHighlight(table)
	local group, type = table.group, table.type
	return PitBull_Aura.db.profile[group].highlight[type]
end

local function setHighlight(table, value)
	local group, type = table.group, table.type
	PitBull_Aura.db.profile[group].highlight[type] = value
	updategroup(group)
end

local function getTypeHighlight(group)
	return PitBull_Aura.db.profile[group].highlightType
end

local function setTypeHighlight(group, value)
	PitBull_Aura.db.profile[group].highlightType = value
	updategroup(group)
end

local function getHighlightColor(table)
local type, type2 = table[1], table[2]
	return unpack(type2 and PitBull_Aura.db.profile.colors[type][type2] or PitBull_Aura.db.profile.colors[type])
end

local function setHighlightColor(table, r, g, b, a)
local type, type2 = table[1], table[2]
	if type2 then
		PitBull_Aura.db.profile.colors[type][type2] = {r, g, b, a}
	else
		PitBull_Aura.db.profile.colors[type] = {r, g, b, a}
	end
	updategroup(group)
end

local function getHighlightStyle(group)
	return PitBull_Aura.db.profile[group].highlightStyle
end

local function setHighlightStyle(group, value)
	PitBull_Aura.db.profile[group].highlightStyle = value
	updategroup(group)
end

local function getEnableFilter(group)
	return PitBull_Aura.db.profile[group].filter
end

local function setEnableFilter(group, value)
	if PitBull_Aura.db.profile[group].filter == value then
		return
	end

	PitBull_Aura.db.profile[group].filter = value
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getFrameHighlight(group)
	return PitBull_Aura.db.profile[group].frameHighlight
end

local function setFrameHighlight(group, value)
	if PitBull_Aura.db.profile[group].frameHighlight == value then
		return
	end

	PitBull_Aura.db.profile[group].frameHighlight = value

	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getBuffSize(group)
	return PitBull_Aura.db.profile[group].buffsize
end

local function setBuffSize(group, value)
	if PitBull_Aura.db.profile[group].buffsize == value then
		return
	end

	PitBull_Aura.db.profile[group].buffsize = value
	
	updategroup(group)
end

local function getDebuffSize(group)
	return PitBull_Aura.db.profile[group].debuffsize
end

local function setDebuffSize(group, value)
	if PitBull_Aura.db.profile[group].debuffsize == value then
		return
	end

	PitBull_Aura.db.profile[group].debuffsize = value
	
	updategroup(group)
end

local function getMaxBuffs(group)
	return PitBull_Aura.db.profile[group].maxbuffs
end

local function setMaxBuffs(group, value)
	if PitBull_Aura.db.profile[group].maxbuffs == value then
		return
	end

	PitBull_Aura.db.profile[group].maxbuffs = value
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getMaxDebuffs(group)
	return PitBull_Aura.db.profile[group].maxdebuffs
end

local function setMaxDebuffs(group, value)
	if PitBull_Aura.db.profile[group].maxdebuffs == value then
		return
	end

	PitBull_Aura.db.profile[group].maxdebuffs = value
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getFlipped(group)
	return PitBull_Aura.db.profile[group].flip
end

local function setFlipped(group, value)
	if PitBull_Aura.db.profile[group].flip == value then
		return
	end

	PitBull_Aura.db.profile[group].flip = value
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getGrowthDirection(group)
	local d = PitBull_Aura.db.profile[group].grow
	if d == 1 then
		return "Up"
	elseif d == -1 then
		return "Down"
	end
end

local function setGrowthDirection(group, value)
	if getGrowthDirection(group) == value then
		return
	end

	if value == "Up" then
		PitBull_Aura.db.profile[group].grow = 1
	elseif value == "Down" then
		PitBull_Aura.db.profile[group].grow = -1
	end
	
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Aura:OnUpdateFrame(unit, frame)
	end
end

local function getBuffDirection(group)
	return PitBull_Aura.db.profile[group].buffdirection
end

local function setBuffDirection(group, value)
	if PitBull_Aura.db.profile[group].buffdirection == value then
		return
	end

	PitBull_Aura.db.profile[group].buffdirection = value
	
	updategroup(group)
end

local function getDebuffDirection(group)
	return PitBull_Aura.db.profile[group].debuffdirection
end

local function setDebuffDirection(group, value)
	if PitBull_Aura.db.profile[group].debuffdirection == value then
		return
	end

	PitBull_Aura.db.profile[group].debuffdirection = value
	
	updategroup(group)
end

local function checkSplitOptionsHidden(group)
	return PitBull_Aura.db.profile[group].split
end

local function checkNonSplitOptionsHidden(group)
	return not PitBull_Aura.db.profile[group].split
end

local buffdirectiontable = {
	["Up then Left"] = L["Up then Left"],
	["Up then Right"] = L["Up then Right"],
	["Down then Left"] = L["Down then Left"],
	["Down then Right"] = L["Down then Right"],
	["Left then Up"] = L["Left then Up"],
	["Left then Down"] = L["Left then Down"],
	["Right then Up"] = L["Right then Up"],
	["Right then Down"] = L["Right then Down"],
}

PitBull_Aura:RegisterPitBullOptionsMethod(function(group)
	return {
		type = "group",
		name = L["Auras"],
		desc = L["Options for buff and debuff display for this unit type."],
		args = {
			Split = {
				type = "toggle",
				name = L["Split"],
				desc = L["Split buff and debuff positions."],
				get = getSplit,
				set = setSplit,
				passValue = group,
				disabled = getHidden,
			},
			Snap = {
				type = "toggle",
				name = L["Snap"],
				desc = L["Resize auras to fill the available row space."],
				get = getSnap,
				set = setSnap,
				passValue = group,
				disabled = getHidden,
			},
			Sort = {
				type = "toggle",
				name = L["Sort"],
				desc = L["Sort this unit's debuffs by type then alphabetically."],
				get = getSort,
				set = setSort,
				passValue = group,
				disabled = getHidden,
			},
			Hide = {
				type = "group",
				name = L["Hide"],
				desc = L["Optionally hide all, buffs or debuffs only."],
				args = {
					All = {
						type = "toggle",
						name = L["All"],
						desc = L["Hide buffs and debuffs."],
						get = getHidden,
						set = setHidden,
						passValue = group,
					},
					Buffs = {
						type = "toggle",
						name = L["Buffs"],
						desc = L["Hide buffs."],
						get = getMultiHidden,
						set = setMultiHidden,
						passValue = {["group"] = group, ["type"] = "Buffs"},
					},
					Debuffs = {
						type = "toggle",
						name = L["Debuffs"],
						desc = L["Hide debuffs."],
						get = getMultiHidden,
						set = setMultiHidden,
						passValue = {["group"] = group, ["type"] = "Debuffs"},
					}
				}
			},
			highlight = {
				type = "group",
				name = L["Highlight"],
				desc = L["Options for highlighting the buff icons."],
				disabled = getHidden,
				passValue = group,
				args = {
					Buffs = {
						type = "toggle",
						name = L["Buffs"],
						desc = L["Highlight buffs."],
						get = getHighlight,
						set = setHighlight,
						passValue = {["group"] = group, ["type"] = "Buffs"},
						disabled = getMultiHidden,
					},
					Debuffs = {
						type = "toggle",
						name = L["Debuffs"],
						desc = L["Highlight debuffs."],
						get = getHighlight,
						set = setHighlight,
						passValue = {["group"] = group, ["type"] = "Debuffs"},
						disabled = getMultiHidden,
					},
					DebuffsType = {
						type = "toggle",
						name = L["Debuff types"],
						desc = L["Highlight different debuffs with different colors based on type."],
						get = getTypeHighlight,
						set = setTypeHighlight,
						passValue = group,
						disabled = getAllOrDebuffHidden,
					},
					Style = {
						type = "text",
						name = L["Style"],
						desc = L["Set how the highlight looks."],
						validate = {
							border = L["Border"],
							normal = L["Normal"],
						},
						get = getHighlightStyle,
						set = setHighlightStyle,
						passValue = group,
						disabled = getAllOrDebuffHidden,
					},
					Colors = {
						type = "group",
						name = L["Colors"],
						desc = L["Set the highlight colors for the various types."],
						args = {
							Buffs = {
								type = "color",
								name = L["Buffs"],
								desc = L["Set the color for buffs."],
								hasAlpha = true,
								get = getHighlightColor,
								set = setHighlightColor,
								passValue = {"buffs"},
							},
							Debuffs = {
								type = "group",
								name = L["Debuffs"],
								desc = L["Set the highlight colors for the various debuff types."],
								args = {
									Curse = {
										type = "color",
										name = L["Curse"],
										desc = L["Set color for curses."],
										hasAlpha = true,
										get = getHighlightColor,
										set = setHighlightColor,
										passValue = {"debuffs", "Curse"},
									},
									Poison = {
										type = "color",
										name = L["Poison"],
										desc = L["Set color for poisons."],
										hasAlpha = true,
										get = getHighlightColor,
										set = setHighlightColor,
										passValue = {"debuffs", "Poison"},
									},
									Magic = {
										type = "color",
										name = L["Magic"],
										desc = L["Set color for magics."],
										hasAlpha = true,
										get = getHighlightColor,
										set = setHighlightColor,
										passValue = {"debuffs", "Magic"},
									},
									Disease = {
										type = "color",
										name = L["Disease"],
										desc = L["Set color for diseases."],
										hasAlpha = true,
										get = getHighlightColor,
										set = setHighlightColor,
										passValue = {"debuffs", "Disease"},
									},
									Other = {
										type = "color",
										name = L["Other"],
										desc = L["Set color for others."],
										hasAlpha = true,
										get = getHighlightColor,
										set = setHighlightColor,
										passValue = {"debuffs", "nil"},
									},
								}
							}
						}
					}
				}
			},
			framehighlight = {
				type = "text",
				name = L["Frame highlight"],
				desc = L["Highlighting the unit frame itself when the unit is debuffed."],
				validate = {
					["Never"] = L["Never"],
					["All Debuffs"] = L["All Debuffs"],
					["Cureable"] = L["Cureable"],
					["Cureable by me"] = L["Cureable by me"],
				},
				get = getFrameHighlight,
				set = setFrameHighlight,
				passValue = group,
			},
			filter = {
				type = "toggle",
				name = L["Enable filtering"],
				desc = L["Filter certain buffs and debuffs based on your class.\n\nNote that what is filtered and not by this option is not controlled by PitBull, but controlled by Blizzard."],
				get = getEnableFilter,
				set = setEnableFilter,
				passValue = group,
				disabled = getHidden,
			},
			debuffsize = {
				type = "range",
				name = L["Debuff size"],
				desc = L["Set size of debuff icons."],
				get = getDebuffSize,
				set = setDebuffSize,
				passValue = group,
				min = 4,
				max = 48,
				step = 1,
				disabled = getAllOrDebuffHidden,
			},
			buffsize = {
				type = "range",
				name = L["Buff size"],
				desc = L["Set size of buff icons."],
				get = getBuffSize,
				set = setBuffSize,
				passValue = group,
				min = 4,
				max = 48,
				step = 1,
				disabled = getAllOrBuffHidden,
			},
			maxbuffs = {
				type = "range",
				name = L["Max buffs"],
				desc = L["Set the maximum number of buffs to display."],
				get = getMaxBuffs,
				set = setMaxBuffs,
				passValue = group,
				min = 0,
				max = 40,
				step = 1,
				disabled = getAllOrBuffHidden,
			},
			maxdebuffs = {
				type = "range",
				name = L["Max debuffs"],
				desc = L["Set the maximum number of debuffs to display."],
				get = getMaxDebuffs,
				set = setMaxDebuffs,
				passValue = group,
				min = 0,
				max = 40,
				step = 1,
				disabled = getAllOrDebuffHidden,
			},
			direction = {
				type = "group",
				name = L["Direction"],
				desc = L["Options for how to position aura icons on this frame."],
				disabled = getHidden,
				passValue = group,
				args = {
					-- options when not in split mode
					flip = {
						type = "toggle",
						name = L["Flip buffs/debuffs"],
						desc = L["Flip the positions of buffs and debuffs."],
						get = getFlipped,
						set = setFlipped,
						passValue = group,
						hidden = checkSplitOptionsHidden,
					},
					grow = {
						type = "text",
						name = L["Growth direction"],
						desc = L["Set the growth direction for extra rows of buffs and debuffs."],
						get = getGrowthDirection,
						set = setGrowthDirection,
						passValue = group,
						validate = {
							["Up"] = L["Up"],
							["Down"] = L["Down"],
						},
						hidden = checkSplitOptionsHidden,
					},
					-- options when in split mode
					buffDirection = {
						type = "text",
						name = L["Buff direction"],
						desc = L["Set the direction in which buffs grow."],
						get = getBuffDirection,
						set = setBuffDirection,
						passValue = group,
						validate = buffdirectiontable,
						hidden = checkNonSplitOptionsHidden,
						disabled = getAllOrBuffHidden,
					},
					debuffDirection = {
						type = "text",
						name = L["Debuff direction"],
						desc = L["Set the direction in which debuffs grow."],
						get = getDebuffDirection,
						set = setDebuffDirection,
						passValue = group,
						validate = buffdirectiontable,
						hidden = checkNonSplitOptionsHidden,
						disabled = getAllOrDebuffHidden,
					},
				},
			},
		}
	}
end)

-- Global settings
PitBull.options.args.global.args.Aura = {
	type = 'group',
	name = L["Aura"],
	desc = L["Aura"],
	args = {
		cooldown = {
			type = 'toggle',
			name = L["Cooldown spiral"],
			desc = L["Toggle whether the cooldown spiral shows."],
			get = function()
				return PitBull_Aura.db.profile.cooldown
			end,
			set = function(value)
				PitBull_Aura.db.profile.cooldown = value
				for unit, frame in PitBull:IterateUnitFrames() do
					self:UpdateAuras(unit, frame)
				end
			end,
		},
		cooldownText = {
			type = 'group',
			name = L["Cooldown text"],
			desc = L["Cooldown text"],
			args = {
				toggle = {
					type = 'toggle',
					name = L["Toggle"],
					desc = L["Toggle whether to show the cooldown text."],
					get = function()
						return PitBull_Aura.db.profile.cooldownText
					end,
					set = function(value)
						PitBull_Aura.db.profile.cooldownText = value
						for unit, frame in PitBull:IterateUnitFrames() do
							self:UpdateAuras(unit, frame)
						end
					end,
				},
				alpha = {
					type = 'range',
					name = L["Opacity"],
					desc = L["How transparent/opaque the cooldown text is."],
					min = 0.05,
					max = 1,
					step = 0.01,
					bigStep = 0.05,
					get = function()
						return PitBull_Aura.db.profile.cooldownTextAlpha
					end,
					set = function(value)
						local old = PitBull_Aura.db.profile.cooldownText
						PitBull_Aura.db.profile.cooldownText = false
						PitBull_Aura.db.profile.cooldownTextAlpha = value
						for unit, frame in PitBull:IterateUnitFrames() do
							self:UpdateAuras(unit, frame)
						end
						if old then
							PitBull_Aura.db.profile.cooldownText = true
							for unit, frame in PitBull:IterateUnitFrames() do
								self:UpdateAuras(unit, frame)
							end
						end
					end,
				},
			}
		}
	},
}